﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using C1.WPF.FlexGrid;
using System.Collections.ObjectModel;
using System.Reflection;
using System.Windows.Media;

namespace TranposedFlexGrid
{
   public class CustomFlexGrid:C1FlexGrid
   {

       protected override void OnLoadedRows(EventArgs e)
       {
           base.OnLoadedRows(e);
         
           var vm = new TransferViewModel();
          
           this.AutoGenerateColumns = false;
           this.HeadersVisibility = HeadersVisibility.Row;
           this.CellFactory = new TransposeCellFactory();

           //Create Columns manually. The Header would be the required Property value
           for (int i = 0; i < vm.Count; i++)
           {
               this.Columns.Add(new Column() { Tag = vm.Transfers[i], TextWrapping = true });
           }

           /*Add the total rows to be displayed in the grid. 
            These would be same as total columns in the grid Or the total number of properties in the class*/

           this.Rows.Clear();
           var ct = new ClubTransfers();
           foreach (PropertyInfo pi in ct.GetType().GetProperties())
           {
               this.Rows.Add(new Row() { Tag = pi.Name });
           }

           //autosize rows/columns
           this.Loaded += (s1, e1) =>
               {
                   this.AutoSizeRows(0, this.Rows.Count - 1, 0);
                   this.AutoSizeFixedColumn(0, 0);
                   this.AutoSizeFixedRow(0, 0);
                   this.AutoSizeColumns(0, this.Columns.Count - 1, 0);
               };

       }
      
    }
}
