﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using C1.WPF.FlexGrid;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Collections.ObjectModel;
using System.Windows.Media;

namespace TranposedFlexGrid
{
   public class TransposeCellFactory : CellFactory
    {
       
        public override void CreateRowHeaderContent(C1FlexGrid grid, Border bdr, CellRange range)
        {
            // Assign text to row headers

            var row = grid.Rows[range.Row];
            var c = grid.Columns[range.Column];
            var textblock = new TextBlock();
            if (row.Tag != null)
            {
                textblock.Text = row.Tag.ToString();
            }
            bdr.Child = textblock;
        }

        public override FrameworkElement CreateCellEditor(C1FlexGrid grid, CellType cellType, CellRange range)
        {
            var row = grid.Rows[range.Row];
            var c = grid.Columns[range.Column];
            var textbox = new TextBox();
            if (row.Tag != null)
            {
                textbox.DataContext = c.Tag;
                var binding = new Binding(row.Tag.ToString()) { Mode = BindingMode.TwoWay };
                textbox.SetBinding(TextBox.TextProperty, binding);

            }
          return textbox; 

        }


        public override void CreateCellContent(C1FlexGrid grid, Border bdr, CellRange range)
        {

            var row = grid.Rows[range.Row];
            var c = grid.Columns[range.Column];
            var textblock = new TextBlock();
            if (c.Tag != null)
            {
                bdr.DataContext = c.Tag ;
                var binding = new Binding(row.Tag.ToString()) { Mode = BindingMode.TwoWay, UpdateSourceTrigger = UpdateSourceTrigger.PropertyChanged };
                textblock.SetBinding(TextBlock.TextProperty, binding);
                bdr.Child = textblock;

            }
        }
    }

}
